import { Buff } from '@cmdcode/buff-utils';
import * as Noble from '@cmdcode/secp256k1';
type FieldValue = string | number | bigint | Uint8Array | Field;
type PointValue = string | number | bigint | Uint8Array | Point;
export declare class Field extends Uint8Array {
    static N: bigint;
    static mod(n: bigint, m?: bigint): bigint;
    static isField: (x: any) => boolean;
    static normalize(num: FieldValue): Uint8Array;
    static validate(num: bigint): boolean;
    constructor(num: FieldValue);
    get buff(): Buff;
    get raw(): Uint8Array;
    get num(): bigint;
    get point(): Point;
    get hasOddY(): boolean;
    get negated(): Field;
    gt(num: FieldValue): boolean;
    lt(num: FieldValue): boolean;
    eq(num: FieldValue): boolean;
    ne(num: FieldValue): boolean;
    add(num: FieldValue): Field;
    sub(num: FieldValue): Field;
    mul(num: FieldValue): Field;
    pow(num: FieldValue, n?: bigint): Field;
    div(num: FieldValue): Field;
    negate(): Field;
}
export declare class Point {
    static N: bigint;
    static validate(x: PointValue): boolean;
    static fromNum(num: PointValue): Point;
    static fromX(x: PointValue): Point;
    static from(point: Point | Noble.Point): Point;
    private readonly __p;
    private readonly __x;
    private readonly __y;
    constructor(x: bigint, y: bigint);
    get p(): Noble.Point;
    get buff(): Buff;
    get hex(): string;
    get hasOddY(): boolean;
    get rawX(): Uint8Array;
    get rawY(): Uint8Array;
    get x(): bigint;
    get y(): bigint;
    eq(x: PointValue): boolean;
    add(x: PointValue): Point;
    sub(x: PointValue): Point;
    mul(x: PointValue): Point;
    negate(): Point;
}
export {};
//# sourceMappingURL=ecc.d.ts.map