import { Buff, Bytes } from '@cmdcode/buff-utils';
import { Field, Point } from './ecc.js';
import { SignatureTypes } from './signer.js';
export declare class KeyPair {
    private readonly _buffer;
    static generate(): KeyPair;
    constructor(secret: Bytes);
    get field(): Field;
    get point(): Point;
    get buff(): Buff;
    get raw(): Uint8Array;
    get hex(): string;
    get pub(): PubKey;
    sign(message: Bytes, type?: SignatureTypes): Promise<Uint8Array>;
    verify(message: Bytes, signature: Bytes, type?: SignatureTypes): Promise<boolean>;
}
export declare class PubKey {
    private readonly _buffer;
    static generate(): PubKey;
    constructor(bytes: Bytes);
    get raw(): Uint8Array;
    get rawX(): Uint8Array;
    get buff(): Buff;
    get hex(): string;
    verify(message: Bytes, signature: Bytes, type?: SignatureTypes): Promise<boolean>;
}
//# sourceMappingURL=keypair.d.ts.map